/*
 *  TEX Device Driver  ver 2.02-2.06
 *  copyright(c) 1988, 1989 by TSG, 1990 by SHIMA
 *
 *  device.h : DEVICE DEFINITION FOR PREVIEWER
 *
 *	modified for non PC-9801 machines by sempa 1992
 *  a very slightly modified for HIRES-9801 by OkI 20th Jun. 1992
 */

/* Device Definitons */

#define DEF_MAG         1000
 /*  default magnification */

#define CRT_WIDTH       (640+(24*32/40)*40*8)
#define CRT_HEIGHT      (-1)
 /*  default device width, height */
 /*  (PreviewerSCROLL̂Ŗ) */
#define CRT_DPI         118
 /*  default DPI */
#ifdef PC9801
#define DEF_PK_SIZE     0L	/* 0L: the buffer is obtained in GVRAM */
#else
#define DEF_PK_SIZE     0xffffL
#endif

#define DEF_RASTER_SIZE 80000L
#define DEF_BITMAP_SIZE 0L
#define DEF_WORK_SIZE   -1L
 /*  default Buffer size */

#define MAX_FONTS       256
 /*  max fonts */

#define DEF_PRINT_DIR   HORIZONTAL
 /*  default print direction */

#ifdef HIRES98
#define HORI_DIVIDE     32	/* H98 mC^[[X̊֌W */
#else
#define HORI_DIVIDE     16
#endif
#define VERT_DIVIDE     8
 /*  ̒lŁC\傫؂悤ɂD
     */

/* end of file : device.h */
