/*
 *  TEX Device Driver  ver 2.00
 *  copyright(c) 1988, 1989 by TSG.
 *
 *  dviread.h : t@C琔lǂݏo
 */

#define read_byte(f)    getc(f)

#if defined(TURBOC) || defined(MSC)
 /*  read_int is modified for 16-bit-length integer. */
int read_int(FILE *);
long read_mid(FILE *);
long read_long(FILE *);

#elif defined(x68k)
 /* integer is 32-bit length */
#define read_int(f)     signed_read_n(f,2)
#define read_mid(f)     signed_read_n(f,3)
#define read_long(f)    signed_read_n(f,4)

#endif

char *read_str(FILE *, int);

 /* read strings from disk */
long read_n(FILE *, int);
long signed_read_n(FILE *, int);

 /* read 1-4 bytes from disk */

/* end of file : dviread.h */
