    name    bufclr
BUFCLR_TEXT   segment byte public 'CODE'
BUFCLR_TEXT   ends
DGROUP  group   _DATA,_BSS
    assume  cs:BUFCLR_TEXT,ds:DGROUP,ss:DGROUP
;    assume  cs:BUFCLR_TEXT,ds:DGROUP
_DATA   segment word public 'DATA'
_DATA   ends
_BSS    segment word public 'BSS'
_BSS    ends

BUFCLR_TEXT   segment byte public 'CODE'

public _clear_buf

clear60k    proc    far
    push    di
    push    ax
    mov cx, 7800h
    mov ax, 0
    cld
    rep stosw
    pop ax
    pop di
    ret
clear60k endp

clear_byte  proc far
    push    di
    mov cx, ax
    mov ax, 0
    cld
    shr	cx, 1
    jnc	skip_1
    stosb

skip_1:
    jcxz skip_2
    rep stosw

skip_2:
    pop di
    ret
clear_byte endp

_clear_buf  proc    far
    push    bp
    mov bp,sp
    push    es
    push    di

; es:di = buffer pointer
    mov bx,word ptr [bp+6]
    les di,[bx]
    mov ax,es
    mov cl,4
    mov bx,di
    shr bx,cl
    and bx,0fffh
    add ax,bx
    mov es,ax
    and di,000fh

; dx:ax = size
    mov bx,word ptr [bp+6]
    mov dx,word ptr [bx+14]
    mov ax,word ptr [bx+12]
    jmp short loop_check

loop_60k:
    call far ptr clear60k

loop_reinit:
    mov bx,es
    add bx,0f00h
    mov es,bx
    sub ax, 0f000h
    sbb dx, 0

loop_check:
    cmp ax, 0f000h
    jnc loop_60k
    cmp dx,1
    jge loop_60k

loop_end:
    cmp ax, 0
    je ptr_init

    call far ptr clear_byte

ptr_init:
    mov bx,word ptr [bp+6]
    mov dx,word ptr [bx+2]
    mov ax,word ptr [bx]
    mov word ptr [bx+6],dx
    mov word ptr [bx+4],ax

    pop di
    pop es
    pop bp
    ret 
_clear_buf  endp
BUFCLR_TEXT   ends

BUFCLR_TEXT   segment byte public 'CODE'
    public  _clear_buf
BUFCLR_TEXT   ends
    end
