/*
 *  option.h : standard option-parse module HEADER
 *             programed by T.IWAI
 */

typedef enum ARG_TYPE {	/* enable the `Hidden option' (Naochan!) */
	BOOLEAN, INTEGER, LONGINT, STRING, PROCEDURE, LENGTH,
	HIDDEN_BOOLEAN, HIDDEN_INTEGER, HIDDEN_LONGINT, HIDDEN_STRING,
	HIDDEN_PROCEDURE, HIDDEN_LENGTH,
} ARG_TYPE;
/* LENGTH, HIDDEN_LENGTH is added by
 * K.Yoshizawa Dec. 27. 1992
 */

typedef struct {
	char *option;
	ARG_TYPE type;
	void far *var;
	char *message;
}

ARG_TABLE;

void set_option(ARG_TABLE *, int, char **);
void set_config(ARG_TABLE *, char *);
void option_usage(ARG_TABLE *);

#define	AsAbove "\x01"

/* end of file : option.h */
